Index: pplinux/linuxnew/arch/ppc/platforms/peppercon.c
diff -u /dev/null pplinux/linuxnew/arch/ppc/platforms/peppercon.c:1.1
--- /dev/null	Tue May 24 10:37:58 2005
+++ pplinux/linuxnew/arch/ppc/platforms/peppercon.c	Thu Feb  3 11:35:37 2005
@@ -0,0 +1,375 @@
+/*
+ *
+ *    Copyright (c) 2003 Peppercon AG
+ *
+ *    Module name: peppercon.c
+ *
+ *    Description:
+ *      Architecture- / platform-specific boot-time initialization code for
+ *      Peppercons remote management boards.
+ *
+ * Please read the COPYING file for all license details.
+ */
+#include <linux/config.h>
+#include <linux/init.h>
+#include <linux/smp.h>
+#include <linux/threads.h>
+#include <linux/param.h>
+#include <linux/string.h>
+#include <linux/blk.h>
+#include <linux/pci.h>
+#include <linux/rtc.h>
+#include <linux/console.h>
+#include <linux/timer.h>
+#include <linux/module.h>
+
+#include <asm/system.h>
+#include <asm/pci-bridge.h>
+#include <asm/processor.h>
+#include <asm/machdep.h>
+#include <asm/page.h>
+#include <asm/time.h>
+#include <asm/io.h>
+#include <asm/todc.h>
+#include <asm/ppc4xx_i2c.h>
+#include <platforms/ibm_ocp.h>
+#include <platforms/ibm405ep.h>
+
+#undef DEBUG
+
+#ifdef DEBUG
+#define DBG(x...) printk(x)
+#else
+#define DBG(x...)
+#endif
+
+#ifdef PP_FEAT_SYSOK_BLINKING
+# define GPIO_REGS_ADDR		(GPIO0_BASE)
+# define GPIO_REGS_SIZE		((size_t)0x20)
+
+static struct timer_list status_led_timer;
+static volatile u32 * gpio_regs;
+static unsigned char status_led_state;
+static unsigned char status_led_initialized = 0;
+
+static int  status_led_init(void);
+static void status_led_toggle(unsigned long data);
+#endif
+
+#ifdef CONFIG_PCI
+/*
+ * Some IRQs unique to Peppercon boards.
+ * Used by the generic 405 PCI setup functions in ppc4xx_pci.c
+ */
+int __init
+ppc405_map_irq(struct pci_dev *dev, unsigned char idsel, unsigned char pin)
+{
+	static char pci_irq_table[][4] =
+	    /*
+	     *      PCI IDSEL/INTPIN->INTLINE
+	     *      A       B       C       D
+	     */
+	{
+		{31, 31, 31, 0},        /* IDSEL 1 - ??? */
+		{30, 30, 30, 0},        /* IDSEL 2 - ??? */
+		{29, 29, 29, 0},        /* IDSEL 3 - ??? */
+		{ 0,  0,  0, 0},        /* IDSEL 4 - ??? */
+	};
+
+	const long min_idsel = 1, max_idsel = 4, irqs_per_slot = 3;
+	return PCI_IRQ_TABLE_LOOKUP;
+};
+#endif
+
+void __init
+board_setup_arch(void)
+{
+#if defined(CONFIG_VT) && defined(CONFIG_DUMMY_CONSOLE)
+	conswitchp = &dummy_con;
+#endif
+	/* Identify the system */
+	printk("Peppercon port (C) 2001-2003 Peppercon AG\n");
+}
+
+#ifdef CONFIG_PCI
+void __init
+bios_fixup(struct pci_controller *hose, struct pcil0_regs *pcip)
+{
+}
+#endif
+
+void __init
+board_io_mapping(void)
+{
+}
+
+void __init
+board_setup_irq(void)
+{
+}
+
+#define RTC_READ_SAVE(off, buf, count)			\
+	if ((rtc_ret = rtc_read(off, buf, count))) {	\
+		goto rtc_error;				\
+	}
+#define RTC_WRITE_SAVE(off, buf, count)			\
+	if ((rtc_ret = rtc_write(off, buf, count))) {	\
+		goto rtc_error;				\
+	}
+
+long __init
+pp_time_init(void)
+{
+	static int not_initialized = 1;
+
+        /* Make sure clocks are running */
+        if (not_initialized) {
+		unsigned char century, year, mon, day, mday, hour, min, sec;
+		unsigned char rtc_val = 0;
+		int rtc_ret;
+
+		i2c_init();
+
+		RTC_READ_SAVE(X1240_STATUS, (unsigned char *)&rtc_val, 1);
+		
+		if (rtc_val & X1240_STATUS_BATTERY_FLAG) {
+			printk(KERN_INFO "Real Time Clock battery exhuasted, value of RTC may be incorrect\n");
+		}
+#if 0
+		printk(KERN_INFO "RTC X1240: Status %02x\n",rtc_val);
+#endif	
+	
+		/* unlock Register write access */
+		rtc_val = X1240_STATUS_WEL;
+		RTC_WRITE_SAVE(X1240_STATUS, &rtc_val, 1);
+		rtc_val |= X1240_STATUS_RWEL;
+		RTC_WRITE_SAVE(X1240_STATUS, &rtc_val, 1);
+	
+		RTC_READ_SAVE(X1240_STATUS, &rtc_val, 1);
+	
+		/* 
+		 * start a new powered on rtc
+		 * a simple write turns on the RTC
+		 */
+		if (rtc_val & X1240_STATUS_RTCF){
+			rtc_read(X1240_Y2K, &century, 1);
+			rtc_write(X1240_Y2K, &century, 1);
+		}
+	
+		/* lock Register write access, leave EEPROM enabled */
+		rtc_val = X1240_STATUS_WEL;
+		RTC_WRITE_SAVE(X1240_STATUS, &rtc_val, sizeof(rtc_val));
+	
+		RTC_READ_SAVE(X1240_SC,  &sec, 1);
+		RTC_READ_SAVE(X1240_MIN, &min, 1);
+		RTC_READ_SAVE(X1240_HR,  &hour, 1);
+		RTC_READ_SAVE(X1240_DT,  &mday, 1);
+		RTC_READ_SAVE(X1240_MO,  &mon, 1);
+		RTC_READ_SAVE(X1240_YR,  &year, 1);
+		RTC_READ_SAVE(X1240_DW,  &day, 1); day++;
+		RTC_READ_SAVE(X1240_Y2K, &century, 1);
+
+#if 0
+		printk(KERN_INFO "RTC X1240: Time: %02x:%02x:%02x Date: %1x. %02x%02x/%02x/%02x\n",
+		       hour & 0x3f,min,sec,day,century,year,mon,mday);
+#endif
+
+		not_initialized = 0;
+        }
+
+#ifdef PP_FEAT_SYSOK_BLINKING
+	if (status_led_init() == 0) {
+	    status_led_initialized = 1;
+	}
+	pp_status_led_blinking(1);
+#endif
+
+	return 0;
+
+rtc_error:
+	printk(KERN_INFO "RTC X1240: Error while accessing RTC\n");
+	return -1;
+}
+
+int
+pp_set_rtc_time(unsigned long nowtime)
+{
+	struct rtc_time tm;
+	unsigned char rtc_val = 0;
+	unsigned int  save_year;
+        unsigned char century;
+	int rtc_ret;
+
+	to_tm(nowtime, &tm);
+
+	save_year  = tm.tm_year;
+	tm.tm_year = (tm.tm_year - 1900) % 100;
+	century    = (save_year - tm.tm_year) / 100;
+
+	BIN_TO_BCD(tm.tm_sec);
+	BIN_TO_BCD(tm.tm_min);
+	BIN_TO_BCD(tm.tm_hour);
+	BIN_TO_BCD(tm.tm_mon);
+	BIN_TO_BCD(tm.tm_mday);
+	BIN_TO_BCD(tm.tm_year);
+	BIN_TO_BCD(century);
+
+	spin_lock(&rtc_lock);
+
+	/* unlock Register write access */
+	rtc_val = X1240_STATUS_WEL;
+	RTC_WRITE_SAVE(X1240_STATUS, &rtc_val, 1);
+	rtc_val |= X1240_STATUS_RWEL;
+	RTC_WRITE_SAVE(X1240_STATUS, &rtc_val, 1);
+
+	rtc_val = tm.tm_sec  & 0x7f;
+	RTC_WRITE_SAVE(X1240_SC,  &rtc_val, 1);
+
+	rtc_val = tm.tm_min  & 0x7f;
+	RTC_WRITE_SAVE(X1240_MIN, &rtc_val, 1);
+
+	rtc_val = (tm.tm_hour & 0x3f) | X1240_HR_MIL; /* set 24 hour mode*/
+	RTC_WRITE_SAVE(X1240_HR,  &rtc_val, 1);
+
+	rtc_val = tm.tm_mday & 0x3f;
+	RTC_WRITE_SAVE(X1240_DT,  &rtc_val, 1);
+
+	rtc_val = tm.tm_mon  & 0x1f;
+	RTC_WRITE_SAVE(X1240_MO,  &rtc_val, 1);
+
+	rtc_val = tm.tm_year;
+	RTC_WRITE_SAVE(X1240_YR,  &rtc_val, 1);
+
+//      rtc_write(X1240_DW,  &rtc_val, 1);
+
+	rtc_val = (century   & 0x3f);
+	RTC_WRITE_SAVE(X1240_Y2K, &rtc_val, 1);
+
+	/* lock Register write access, leave EEPROM enabled */
+	rtc_val = X1240_STATUS_WEL;
+	RTC_WRITE_SAVE(X1240_STATUS, &rtc_val, 1);
+
+	spin_unlock(&rtc_lock);
+	return 0;
+
+rtc_error:
+	spin_unlock(&rtc_lock);
+	printk(KERN_INFO "RTC X1240: Error while accessing RTC\n");
+	return -1;
+}
+
+unsigned long
+pp_get_rtc_time(void)
+{
+        unsigned int century, year, mon, mday, hour, min, sec;
+	unsigned char rtc_val;
+        int rtc_ret;
+
+	spin_lock(&rtc_lock);
+
+        RTC_READ_SAVE(X1240_SC,  &rtc_val, 1);
+        sec = (unsigned int) rtc_val & 0x7f;
+
+        RTC_READ_SAVE(X1240_MIN, &rtc_val, 1);
+        min = (unsigned int) rtc_val & 0x7f;
+
+        RTC_READ_SAVE(X1240_HR,  &rtc_val, 1);
+        hour = (unsigned int) rtc_val & 0x3f;
+
+        RTC_READ_SAVE(X1240_DT,  &rtc_val, 1);
+        mday = (unsigned int) rtc_val & 0x3f;
+
+        RTC_READ_SAVE(X1240_MO,  &rtc_val, 1);
+        mon = (unsigned int) rtc_val & 0x1f;
+
+        RTC_READ_SAVE(X1240_YR,  &rtc_val, 1);
+        year = (unsigned int) rtc_val;
+
+//      RTC_READ_SAVE(X1240_DW,  &rtc_val, 1);
+
+        RTC_READ_SAVE(X1240_Y2K, &rtc_val, 1);
+        century = (unsigned int) rtc_val & 0x3f;
+
+	spin_unlock(&rtc_lock);
+
+	BCD_TO_BIN(sec);
+	BCD_TO_BIN(min);
+	BCD_TO_BIN(hour);
+	BCD_TO_BIN(mday);
+	BCD_TO_BIN(mon);
+	BCD_TO_BIN(year);
+	BCD_TO_BIN(century);
+
+        year = year + (100 * century);
+
+#if 0
+        printk(KERN_INFO "RTC X1240 gettime(): Time: %02x:%02x:%02x Date: %02x%02x/%02x/%02x\n",
+	       hour & 0x3f,min,sec,century,year,mon,mday);
+#endif
+
+        return mktime(year, mon, mday, hour, min, sec);
+
+rtc_error:
+	spin_unlock(&rtc_lock);
+	printk(KERN_ALERT "RTC X1240: Error while accessing RTC\n");
+        return -1;
+}
+
+void __init
+board_init(void)
+{
+	ppc_md.time_init = pp_time_init;
+	ppc_md.set_rtc_time = pp_set_rtc_time;
+	ppc_md.get_rtc_time = pp_get_rtc_time;
+}
+
+#ifdef PP_FEAT_SYSOK_BLINKING
+EXPORT_SYMBOL(pp_status_led_blinking);
+void
+pp_status_led_blinking(unsigned char blinking)
+{
+    if (!status_led_initialized) return;
+    
+    del_timer_sync(&status_led_timer);
+        
+    if (blinking) {
+	init_timer(&status_led_timer);
+	status_led_timer.expires = jiffies + HZ/10;
+	status_led_timer.data = 0;
+	status_led_timer.function = status_led_toggle;
+	add_timer(&status_led_timer);
+    } else {
+	// if not blinking, turn on unconditioally
+	status_led_state = 1;
+	clear_bit((31 - 9), &gpio_regs[0]);
+    }
+}
+
+static int
+status_led_init(void)
+{
+    int ret = 0;
+    
+    gpio_regs = ioremap_nocache(GPIO0_BASE, GPIO_REGS_SIZE);
+    if (gpio_regs == NULL) {
+	printk("Failed to map GPIO registers\n");
+	ret = -1;
+    }
+
+    return ret;
+}
+
+static void
+status_led_toggle(unsigned long data)
+{
+    if (status_led_state) {
+	set_bit((31 - 9), &gpio_regs[0]);
+    } else {
+	clear_bit((31 - 9), &gpio_regs[0]);
+    }
+
+    status_led_state = (status_led_state) ? 0 : 1;
+    status_led_timer.expires = jiffies + HZ/10;
+    add_timer(&status_led_timer);
+}
+#endif
Index: pplinux/linuxnew/arch/ppc/platforms/peppercon.h
diff -u /dev/null pplinux/linuxnew/arch/ppc/platforms/peppercon.h:1.2
--- /dev/null	Tue May 24 10:37:58 2005
+++ pplinux/linuxnew/arch/ppc/platforms/peppercon.h	Fri Apr 29 10:43:28 2005
@@ -0,0 +1,90 @@
+/*
+ *
+ *    Copyright (c) 2003 Peppercon AG
+ *
+ *    Module name: peppercon.h
+ *
+ *    Description:
+ *      Macros, definitions, and data structures specific to Peppercon's
+ *      remote management boards.
+ *
+ * Please read the COPYING file for all license details.
+ */
+
+#ifdef __KERNEL__
+#ifndef __ASM_PEPPERCON_H__
+#define __ASM_PEPPERCON_H__
+
+#include <linux/config.h>
+#if defined(CONFIG_405GP)
+# include <platforms/ibm405gp.h>
+#elif defined(CONFIG_405EP)
+# include <platforms/ibm405ep.h>
+#else
+# error Unexpected processor type!
+#endif
+
+#ifndef __ASSEMBLY__
+/*
+ * Data structure defining board information maintained by the boot
+ * ROM on IBM's "Walnut" evaluation board. An effort has been made to
+ * keep the field names consistent with the 8xx 'bd_t' board info
+ * structures.
+ */
+
+typedef struct board_info {
+	unsigned long	bi_memstart;	/* start of  DRAM memory              */
+	unsigned long	bi_memsize;	/* size  of  DRAM memory in bytes     */
+	unsigned long	bi_flashstart;	/* start of FLASH memory              */
+	unsigned long	bi_flashsize;	/* size  of FLASH memory              */
+	unsigned long	bi_flashoffset;	/* reserved area for startup monitor  */
+	unsigned long	bi_sramstart;	/* start of  SRAM memory              */
+	unsigned long	bi_sramsize;	/* size  of  SRAM memory              */
+	unsigned long	bi_bootflags;	/* boot / reboot flag (for LynxOS)    */
+	unsigned long	bi_ip_addr;	/* IP Address                         */
+	unsigned char	bi_enetaddr[2][6]; /* Ethernet adress                 */
+	unsigned short	bi_ethspeed;	/* Ethernet speed in Mbps             */
+	unsigned long	bi_intfreq;	/* Internal Freq, in MHz              */
+	unsigned long	bi_busfreq;	/* Bus Freq, in MHz                   */
+	unsigned long	bi_baudrate;	/* Console Baudrate                   */
+	unsigned char	bi_s_version[4];/* Version of this structure          */
+	unsigned char	bi_r_version[32];/* Version of the ROM (IBM)          */
+	unsigned int	bi_procfreq;	/* CPU (Internal) Freq, in Hz         */
+	unsigned int	bi_plb_busfreq;	/* PLB Bus speed, in Hz               */
+	unsigned int	bi_pci_busfreq;	/* PCI Bus speed, in Hz               */
+	unsigned char	bi_pci_enetaddr[6];/* PCI Ethernet MAC address        */
+	unsigned int	bi_debug_mode;  /* 1 if debug cable detected          */
+	unsigned int    bi_def_jumper_set; /* defaults jumper state           */
+	unsigned int    bi_cable_kme;    /* 1 if cable kme was detected       */
+	unsigned int    bi_config_mode;  /* 1 if config command used for boot */
+	unsigned int	bi_opb_busfreq;	 /* OPB Bus speed, in Hz	      */
+	int		bi_iic_fast[1];	 /* Use fast i2c mode		      */
+	unsigned char   bi_hwid;	 /* hardware id of the board	      */
+        unsigned int	bi_epb_busfreq;	 /* EPB Bus speed, in Hz	      */
+} bd_t;
+
+/* Some 4xx parts use a different timebase frequency from the internal clock.
+*/
+#define bi_tbfreq bi_intfreq
+
+
+/* Memory map for the Peppercon boards.  */
+
+#ifdef CONFIG_PPC405GP_INTERNAL_CLOCK
+#define BASE_BAUD		201600
+#else
+#define BASE_BAUD		691200
+#endif
+
+#define PPC4xx_MACHINE_NAME	"Peppercon"
+
+#define RTC_ALWAYS_BCD  1
+
+#ifdef PP_FEAT_SYSOK_BLINKING
+extern void pp_status_led_blinking(unsigned char blinking);
+#endif
+
+#endif /* !__ASSEMBLY__ */
+#endif /* __ASM_PEPPERCON_H__ */
+
+#endif /* __KERNEL__ */
Index: pplinux/linuxnew/drivers/char/ppc405_wdt.c
diff -u pplinux/linuxnew/drivers/char/ppc405_wdt.c:1.1.323.1 pplinux/linuxnew/drivers/char/ppc405_wdt.c:1.3
--- pplinux/linuxnew/drivers/char/ppc405_wdt.c:1.1.323.1	Thu Feb  3 10:00:34 2005
+++ pplinux/linuxnew/drivers/char/ppc405_wdt.c	Wed Feb 23 18:03:37 2005
@@ -65,9 +65,6 @@
 #include <asm/machdep.h>
 #include <asm/hardirq.h>
 
-#define WDIOC_GETPERIOD         _IOR(WATCHDOG_IOCTL_BASE, 6, int)
-#define WDIOC_SETPERIOD         _IOW(WATCHDOG_IOCTL_BASE, 7, int)
-
 int wdt_enable;
 unsigned long wdt_period;
 int wdt_default = 1;
@@ -188,7 +185,7 @@
 				printk(KERN_NOTICE "Soft watchdog timer is enabled\n");
 				break;
 			}
-		case WDIOC_GETPERIOD:
+		case WDIOC_GETTIMEOUT:
 			/* return watchdog period (units = microseconds) */
 			period = (wdt_period / HZ) * MICROSECBASE;
 			if (copy_to_user((unsigned long *)arg, &period, 
@@ -196,7 +193,7 @@
 				return -EFAULT;
 			}
 			break;
-		case WDIOC_SETPERIOD:
+		case WDIOC_SETTIMEOUT:
 			/*
 			** set watchdog period (units = microseconds)
 			** value of zero means maximum
@@ -233,8 +230,8 @@
 			if (period == 0)
 				period = MAXONEHOUR * MICROSECBASE;        
 
-			heartbeat_count(0) = (period / TENMSBASE) +
-				(period % TENMSBASE ? 1 : 0);
+			wdt_period = ((period / TENMSBASE) +
+				(period % TENMSBASE ? 1 : 0)) / HZ;
 			ppc405wd_update_timer();
 
 			break;
Index: pplinux/linuxnew/drivers/char/serial.c
diff -u pplinux/linuxnew/drivers/char/serial.c:1.1.323.1 pplinux/linuxnew/drivers/char/serial.c:1.2
--- pplinux/linuxnew/drivers/char/serial.c:1.1.323.1	Thu Feb  3 10:00:35 2005
+++ pplinux/linuxnew/drivers/char/serial.c	Thu Feb  3 11:35:37 2005
@@ -1361,7 +1361,7 @@
 		} else 
 			handler = rs_interrupt_single;
 
-		retval = request_irq(state->irq, handler, SA_SHIRQ,
+		retval = request_irq(state->irq, handler, SA_SHIRQ|SA_SAMPLE_RANDOM,
 				     "serial", &IRQ_ports[state->irq]);
 		if (retval) {
 			if (capable(CAP_SYS_ADMIN)) {
@@ -1514,7 +1514,7 @@
 		if (IRQ_ports[state->irq]) {
 			free_irq(state->irq, &IRQ_ports[state->irq]);
 			retval = request_irq(state->irq, rs_interrupt_single,
-					     SA_SHIRQ, "serial",
+					     SA_SHIRQ|SA_SAMPLE_RANDOM, "serial",
 					     &IRQ_ports[state->irq]);
 			
 			if (retval)
@@ -1693,7 +1693,7 @@
 			/* Special case since 134 is really 134.5 */
 			quot = (2*baud_base / 269);
 		else if (baud)
-			quot = baud_base / baud;
+			quot = ((baud_base * 10) / baud + 5) / 10;
 	}
 	/* If the quotient is zero refuse the change */
 	if (!quot && old_termios) {
@@ -1710,7 +1710,7 @@
 				/* Special case since 134 is really 134.5 */
 				quot = (2*baud_base / 269);
 			else if (baud)
-				quot = baud_base / baud;
+				quot = ((baud_base * 10) / baud + 5) / 10; 
 		}
 	}
 	/* As a last resort, if the quotient is zero, default to 9600 bps */
@@ -2529,7 +2529,7 @@
 		else
 			handler = rs_interrupt;
 
-		retval = request_irq(state->irq, handler, SA_SHIRQ,
+		retval = request_irq(state->irq, handler, SA_SHIRQ|SA_SAMPLE_RANDOM,
 				     "serial", &IRQ_ports[state->irq]);
 		if (retval) {
 			printk("Couldn't reallocate serial interrupt "
@@ -5890,7 +5890,7 @@
 	static struct async_struct *info;
 	struct serial_state *state;
 	unsigned cval;
-	int	baud = 9600;
+	int	baud = 115200;
 	int	bits = 8;
 	int	parity = 'n';
 	int	doflow = 0;
@@ -5978,7 +5978,7 @@
 	info->io_type = state->io_type;
 	info->iomem_base = state->iomem_base;
 	info->iomem_reg_shift = state->iomem_reg_shift;
-	quot = state->baud_base / baud;
+	quot = ((state->baud_base * 10) / baud + 5) / 10;
 	cval = cflag & (CSIZE | CSTOPB);
 #if defined(__powerpc__) || defined(__alpha__)
 	cval >>= 8;
